package com.example.vaadinlayouts;

import javax.servlet.annotation.WebServlet;

import com.vaadin.annotations.Theme;
import com.vaadin.annotations.VaadinServletConfiguration;
import com.vaadin.server.VaadinRequest;
import com.vaadin.server.VaadinServlet;
import com.vaadin.ui.AbsoluteLayout;
import com.vaadin.ui.Button;
import com.vaadin.ui.CssLayout;
import com.vaadin.ui.CustomLayout;
import com.vaadin.ui.GridLayout;
import com.vaadin.ui.HorizontalLayout;
import com.vaadin.ui.Label;
import com.vaadin.ui.UI;
import com.vaadin.ui.VerticalLayout;

@SuppressWarnings("serial")
@Theme("vaadinlayouts")
public class VaadinlayoutsUI extends UI {

	@WebServlet(value = "/*", asyncSupported = true)
	@VaadinServletConfiguration(productionMode = false, ui = VaadinlayoutsUI.class, widgetset = "com.example.vaadinlayouts.widgetset.VaadinlayoutsWidgetset")
	public static class Servlet extends VaadinServlet {
	}

	@Override
	protected void init(VaadinRequest request) {
		final GridLayout mainLayout = new GridLayout(3,2);
		mainLayout.setSpacing(true);
		mainLayout.setStyleName("black");
		mainLayout.setWidth("90%");
		mainLayout.setHeight("90%");
		setContent(mainLayout);
		
		Label lVerticalBlue = new Label("VerticalLayout");
		lVerticalBlue.setSizeFull();
		lVerticalBlue.addStyleName("grey");

		Label lVerticalGreen = new Label("VerticalLayout");
		lVerticalGreen.setSizeFull();
		lVerticalGreen.addStyleName("green");

		Label lVerticalRed = new Label("VerticalLayout");
		lVerticalRed.setSizeFull();
		lVerticalRed.addStyleName("red");

		VerticalLayout verticalLayout = new VerticalLayout();
		verticalLayout.setSpacing(true);
		verticalLayout.addComponent(lVerticalBlue);
		verticalLayout.addComponent(lVerticalGreen);
		verticalLayout.addComponent(lVerticalRed);
		

		Label lHorizontalBlue = new Label("HorizontalLayout");
		lHorizontalBlue.setSizeFull();
		lHorizontalBlue.addStyleName("grey");

		Label lHorizontalGreen = new Label("HorizontalLayout");
		lHorizontalGreen.setSizeFull();
		lHorizontalGreen.addStyleName("green");

		Label lHorizontalRed = new Label("HorizontalLayout");
		lHorizontalRed.setSizeFull();
		lHorizontalRed.addStyleName("red");

		HorizontalLayout horizontalLayout = new HorizontalLayout();
		horizontalLayout.setSpacing(true);
		horizontalLayout.addComponent(lHorizontalBlue);
		horizontalLayout.addComponent(lHorizontalGreen);
		horizontalLayout.addComponent(lHorizontalRed);
		
		Button bt00 = new Button("0,0");
		Button bt01 = new Button("0,1");
		Button bt10 = new Button("1,0");
		Button bt11 = new Button("1,1");
		
		GridLayout gridLayout = new GridLayout(2, 2);
		gridLayout.setSpacing(true);
		gridLayout.addComponent(bt00,0,0);
		gridLayout.addComponent(bt01,0,1);
		gridLayout.addComponent(bt10,1,0);
		gridLayout.addComponent(bt11,1,1);

		
		AbsoluteLayout absoluteLayout = new AbsoluteLayout();
		absoluteLayout.setWidth("200px");
		absoluteLayout.setHeight("200px");
		absoluteLayout.setStyleName("grey");
		Label l50 = new Label("Absolute x=10/y=10");
		l50.setStyleName("green");
		//l50.setWidth("20px");
		absoluteLayout.addComponent(l50, "left: 10px; top: 10px;");
		
		CssLayout cssLayout = new CssLayout();
		Label lCssGrey = new Label("Css Layout");
		lCssGrey.addStyleName("grey");
		Label lCssGreen = new Label("Css Layout");
		lCssGreen.addStyleName("green");
		Label lCssRed = new Label("Css Layout");
		lCssRed.addStyleName("red");
		cssLayout.addComponent(lCssRed);
		cssLayout.addComponent(lCssGrey);
		cssLayout.addComponent(lCssGreen);
		
		Label lCustomGrey = new Label("Custom Layout");
		lCustomGrey.addStyleName("grey");
		Label lCustomGreen = new Label("Custom Layout");
		lCustomGreen.addStyleName("green");
		Label lCustomRed = new Label("Custom Layout");
		lCustomRed.addStyleName("red");
		CustomLayout customLayout = new CustomLayout("customlayout");
		customLayout.addComponent(lCustomRed, "redloc");
		customLayout.addComponent(lCustomGreen, "greenloc");
		customLayout.addComponent(lCustomGrey, "greyloc");
		
		
		mainLayout.addComponent(verticalLayout, 0, 0);
		mainLayout.addComponent(horizontalLayout, 1, 0);
		mainLayout.addComponent(gridLayout, 2, 0);
		mainLayout.addComponent(absoluteLayout, 0, 1);
		mainLayout.addComponent(cssLayout, 1, 1);
		mainLayout.addComponent(customLayout, 2, 1);

		
		
	}

}